import { useSitecoreContext } from '@sitecore-jss/sitecore-jss-nextjs';
import React from 'react';
export function withDatasourceRendering() {
    return function withDatasourceRenderingHoc(componentOrMap) {
        return function WithDatasourceRendering(props) {
            var _a, _b, _c;
            const { sitecoreContext } = useSitecoreContext();
            const siteName = (_b = (_a = sitecoreContext.site) === null || _a === void 0 ? void 0 : _a.name) !== null && _b !== void 0 ? _b : 'default';
            let InjectedComponent;
            if (typeof componentOrMap === 'function') {
                InjectedComponent = componentOrMap;
            }
            else {
                InjectedComponent = componentOrMap[siteName] || componentOrMap['default'];
            }
            if (!props.rendering.dataSource) {
                return React.createElement(InjectedComponent, Object.assign({}, props, { fields: (_c = sitecoreContext.route) === null || _c === void 0 ? void 0 : _c.fields }));
            }
            return React.createElement(InjectedComponent, Object.assign({}, props));
        };
    };
}
